//**********************************************************************
//  OBISHelper
//
//  i-cube, Christian Aymon, 1376 Goumoens-la-Ville, Switzerland
//          infos@icube.ch
//
// (C)Copyright 2010-2012
//**********************************************************************
#include "stdafx.h"
#include <windows.h>
#include <string>
#include <iostream>
#include "OBISHelperInterface.h"
#include <cstdlib>
using namespace std;

const int MaxOBISTextSize = 500;

void Writeln(const string &s)
{
  cout << s << endl;
}


string GetPathFromFileName( const string& filename )
{
	return filename.substr( 0, filename.rfind("\\")+1 );
}


void DoOne(const string OBISCode)
{
	char OBISText[MaxOBISTextSize] ;
	if (OBISHelperText(OBISCode.c_str(), OBISText, MaxOBISTextSize))
	{
		Writeln(OBISCode + " is " + string(OBISText));
	}
	else
	{
		Writeln(OBISHelperLastErrorMessage());
	}
	Writeln("");
}



int _tmain(int argc, _TCHAR* argv[])
{
	Writeln(OBISHelperVersion());
	Writeln("");

	// We assume that the csv files are located in the same directory as the
	// executable of this demo application
	char FileName[MAX_PATH];
    GetModuleFileNameA(NULL, FileName, sizeof(FileName));
	string Path = GetPathFromFileName(FileName);

	if (!OBISHelperInitialize(Path.c_str()))
	{
		Writeln(OBISHelperLastErrorMessage());
	}
	else
	{
		DoOne("0.0.1.0.0.255");
		DoOne("0.0.42.0.0.255");
		DoOne("3.0.0.0.0.255");
		DoOne("0000010000FF");
		DoOne("FAKE");
		DoOne("");
		DoOne("123456789abcdef");
	}
	Writeln("Type enter to finish");
	getchar();
return 0;
}

